#!/usr/bin/php
<?php
require(__DIR__.'/../vendor/autoload.php');

use nur\io\csv\CsvReader;
use nur\io\csv\CsvWriter;
use nur\io\fsv\FsvReader;
use nur\io\fsv\FsvWriter;
use nur\io\json\JsonReader;
use nur\io\json\YamlReader;
use nur\io\line\LineReader;
use nur\php\UpdateClassesApp;
use nur\v\bs3\Bs3IconManager;

UpdateClassesApp::run(new class extends UpdateClassesApp {
  const MAPPINGS = [
    "io" => [
      "package" => "nur\\io\\",
      "path" => __DIR__."/../nur_src/io",
      "classes" => [
        LineReader::class,
        CsvReader::class,
        CsvWriter::class,
        FsvReader::class,
        FsvWriter::class,
        JsonReader::class,
        YamlReader::class,
      ],
    ],
    "v-bs3" => [
      "package" => "nur\\v\\bs3\\",
      "path" => __DIR__."/../nur_src/v/bs3",
      "classes" => [
        Bs3IconManager::class,
      ],
    ],
  ];
});
